<template>
  <div>
    <v-row>
      <v-col>
        <v-card class="d-flex justify-end">
          <v-card>
            <v-menu
              ref="menu"
              v-model="menu"
              :close-on-content-click="false"
              transition="scale-transition"
              offset-y
              max-width="290px"
              min-width="auto"
            >
              <template v-slot:activator="{ on, attrs }">
                <v-text-field
                  v-model="date"
                  label="Дата"
                  prepend-icon="mdi-calendar"
                  v-bind="attrs"
                  v-on="on"
                  clearable
                  readonly
                ></v-text-field>
              </template>
              <v-date-picker
                v-model="date"
                no-title
                color="blue lighten-1"
                locale="ru-RU"
                @input="init"
              ></v-date-picker>
            </v-menu>
          </v-card>
          <v-card>
            <v-text-field
              prepend-icon="mdi-magnify"
              v-model="text"
              label="Поиск"
              clearable
              @input="init"
            />
          </v-card>
        </v-card>
      </v-col>
    </v-row>
    <v-row justify="center" align="center">
      <v-col
            v-for="(item, i) in news"
            :key="i"
            cols="12" sm="8" md="4"
      >
        <v-hover
            v-slot="{ hover }"
            open-delay="200"
            close-delay="200"
        >
          <NuxtLink :to="`/news/${item.guid}`" class="text-decoration-none">
            <v-card
              :class="{ 'on-hover': hover }"
              max-width="400"          
              dark
            >
                <v-img
                  v-if="item.media"
                  class="white--text align-end"
                  height="200px"
                  :src="item.media[0].$.url"
                  gradient="to top right, rgba(90,80,70,.6), rgba(25,32,72,.7)"
                >
                  <v-card-title v-text="item.title" />
                </v-img>
                <v-card-title 
                  v-else
                  v-text="item.title"
                  class="mb-5"
                />
                <v-card-subtitle 
                  class="pb-0"
                  v-text="item.formatedDate"
                />
                <v-card-text 
                  v-text="item.content"
                />
            </v-card>
          </NuxtLink>
        </v-hover>
      </v-col>
    </v-row>
    <v-row>
      <v-col class="text-center">
        <v-pagination
          v-model="page"
          :length="paginationLength"
          :total-visible="7"
        ></v-pagination>
      </v-col>
    </v-row>
  </div>
</template>

<script>
import { mapState, mapMutations } from 'vuex'

export default {
  data: vm => ({
    date: null,
    menu: false,
    text: null,
    page: 1,
  }),
  computed: {
    ...mapState([
        "news", 
        "paginationLength", 
        "currentPage", 
        "dateFilterItem",
        "titleFilterItem",
      ])
  },
  mounted() {
    this.date = this.dateFilterItem;
    this.text =  this.titleFilterItem;
    this.page = this.currentPage;
  },
  watch: {
    date(value) {
      this.SET_DATE_FILTER(value);
      this.FILTER_NEWS();
    },
    text(value) {
      this.SET_TITLE_FILTER(value);
      this.FILTER_NEWS();
    },
    page(value) {
      this.SET_CURRENT_PAGE(value);
      this.FILTER_NEWS();
    }
  },
  methods: {
    ...mapMutations(["FILTER_NEWS", "SET_DATE_FILTER", "SET_TITLE_FILTER", "SET_CURRENT_PAGE"]),
    init() {
      this.page = 1;
      this.menu = false;
    }
  }
}
</script>

<style lang="sass" scoped>
.v-card.on-hover.theme--dark
  background-color: rgba(#FFF, 0.8)
  >.v-card__text
    color: #000
  >.v-card__subtitle 
    color: #666
  .v-card__title 
    background-color: rgba(#FFF, 0.5)
    color: #333
</style>